// Author: A.Voss@FH-Aachen.de
//
// undefined behavior in expressions
// tags: -

#include <iostream>
#include <cstdlib>
using namespace std;

#include "../../include/tools.h"

int f(int a, int b) { return a+b; }

int main()
{
    tools_log(); cout << "++i+++i..." << endl;
    
    int i,rc;
    
    /* whats wrong here?
     * order of arg-eval not fixed 
     */
    i = 1;
    rc = f(++i,++i);
    tools_log(); cout << "result rc=" << rc << ", i=" << i << endl;

    /* whats wrong here?
     * same as before 
     */
    i = 1;
    rc = ++i + ++i;
    tools_log(); cout << "result rc=" << rc << ", i=" << i << endl;

    i = 1;
    i = ++i + 1;
    tools_log(); cout << "result i=" << i << endl;
    i = 1;
    i = i++ + 1;
    tools_log(); cout << "result i=" << i << endl;

    /* is that ok?
     * each sub-expression is evaluated in order
     */
    i = 1;
    rc = 32,++i,i++;
    tools_log(); cout << "result rc=" << rc << ", i=" << i << endl;

    i = 1;
    rc = (32,++i,i++);
    tools_log(); cout << "result rc=" << rc << ", i=" << i << endl;

    /* whats wrong here?
     * same idea as comma-op
     */
    i = 1;
    rc = (++i>2) || (i++<2);
    tools_log(); cout << "result rc=" << rc << ", i=" << i << endl;

    /* whats wrong here?
     * refer to "Sequencing points"
     */
    int Q[3];
    i = 1;
    Q[i] = Q[i++];
    
    Q[0] = 23; Q[1] = 42; Q[2] = 95;
    
    // ptr to 3-dim array
    int (*pQ)[3];
    pQ = &Q;
    tools_log(); cout << "result Q[2]=" << Q[2] << endl;
    tools_log(); cout << "  sizeof(Q)=" << sizeof(Q) << ", sizeof(pQ)=" << sizeof(pQ) << endl;
    tools_log(); cout << "  Q=" << Q << ", &Q[0]" << &(Q[0]) << ", pQ=" << pQ << endl;

    // 3-dim array of ptr, compare size with pQ
    int *(pR)[3];
    tools_log(); cout << "  sizeof(pR)=" << sizeof(pR) << endl;
    
    return EXIT_SUCCESS;
}

